from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from PyQt4 import QtXml
from qgis.gui import *
# Initialize Qt resources from file resources.py
import resources
import os
import networkx
import networkx as nx
from networkx import *
from testdialog import testDialog
from testdialog2 import testDialog2

# Our main class for the plugin
class NetworkAnalysis:

  def __init__(self, iface):
    # Save reference to the QGIS interface
    self.iface = iface

  def initGui(self):
    # Create action that will start plugin configuration
    self.action = QAction(QIcon(":/plugins/network_analysis/icon.png"), \
        "Analyse de graphe", self.iface.mainWindow())
    QObject.connect(self.action, SIGNAL("activated()"), self.run)

    # Add toolbar button and menu item
    self.iface.addToolBarIcon(self.action)
    self.iface.addPluginToMenu("&Analyse de graphe...", self.action)

  def unload(self):
    # Remove the plugin menu item and icon
    self.iface.removePluginMenu("&Analyse de graphe...",self.action)
    self.iface.removeToolBarIcon(self.action)
 
  def run(self): 
    # Get the user input, starting with the table name
        global canvas
        canvas = self.iface.mapCanvas()
        global allLayers
        allLayers = canvas.layers()
        global count
        count = canvas.layerCount()
        global lay
        lay=[]
        for i in allLayers:
           lay=lay+[str(i.name())]
        global table_noeud
        self.dlg = testDialog(self.iface.mainWindow())
        self.dlg.ui.comboBox.addItems(lay)
        self.dlg.ui.comboBox_2.addItems(lay)
        QObject.connect(self.dlg.ui.buttonBox, SIGNAL("accepted()"), self.calcul)
        self.dlg.show()

  def calcul(self):
        table_noeud=self.dlg.ui.comboBox.currentText()
        table_arc=self.dlg.ui.comboBox_2.currentText()
        global ind_noeud
        for j in range(count):
          if str(table_noeud)==str(lay[j]) :
            ind_noeud=j
        global ind_arc
        for j in range(count):
          if str(table_arc)==str(lay[j]) :
            ind_arc=j
        global aLayer
        aLayer = allLayers[int(ind_arc)]
        global provider
        provider = aLayer.dataProvider()
        global field
        field=provider.fields()
        global fields
        fields=[]
        fields2=[""]
        for i in field:
          fields=fields+[str(field[i].name())]
          fields2=fields2+[str(field[i].name())]
        self.dlg2 = testDialog2(self.iface.mainWindow())
        self.dlg2.ui.comboBox.addItems(fields)
        self.dlg2.ui.comboBox_2.addItems(fields)
        self.dlg2.ui.comboBox_3.addItems(["non","oui"])
        self.dlg2.ui.comboBox_4.addItems(["non","oui"])
        self.dlg2.ui.comboBox_5.addItems(fields2)
        self.dlg2.ui.comboBox_6.addItems(["Degree","Closeness","Betweenness","Clustering","Vulnerabilite"])
        self.dlg2.ui.comboBox_7.addItems(["oui","non"])
        QObject.connect(self.dlg2.ui.buttonBox, SIGNAL("accepted()"), self.calcul2)
        self.dlg2.show()

  def calcul2(self):
        arc_start=self.dlg2.ui.comboBox.currentText()
        arc_end=self.dlg2.ui.comboBox_2.currentText()
        oriente=self.dlg2.ui.comboBox_3.currentText()
        poids=self.dlg2.ui.comboBox_4.currentText()
        ponderation=self.dlg2.ui.comboBox_5.currentText()
        indicateur=self.dlg2.ui.comboBox_6.currentText()
        norm=self.dlg2.ui.comboBox_7.currentText()
        startind=provider.fieldNameIndex(str(arc_start))
        endind=provider.fieldNameIndex(str(arc_end))
        feat = QgsFeature()
        allAttrs = provider.attributeIndexes()
        provider.select(allAttrs)
        table=[]
        if str(poids)=="non":
         while provider.nextFeature(feat):
          attrs = feat.attributeMap()
          attrsstart=attrs.values()[startind].toInt()[0]
          attrsend=attrs.values()[endind].toInt()[0]
          table=table+[(attrsstart,attrsend)] 
         G=nx.Graph()
         if str(oriente)=="oui" :
          G=nx.DiGraph()
         G.add_edges_from(table)
        if str(poids)=="oui":
         distind=provider.fieldNameIndex(str(ponderation))
         while provider.nextFeature(feat):
          attrs = feat.attributeMap()
          attrsstart=attrs.values()[startind].toInt()[0]
          attrsend=attrs.values()[endind].toInt()[0]
          attrsdist=attrs.values()[distind].toInt()[0]
          table=table+[(attrsstart,attrsend,attrsdist)] 
         G=nx.Graph()
         if str(oriente)=="oui" :
          G=nx.DiGraph()
         G.add_weighted_edges_from(table)
        if str(indicateur)=="Betweenness" and str(poids)=="non" and str(norm)=="non" :
            b=betweenness_centrality(G,normalized=False)
        if str(indicateur)=="Betweenness" and str(poids)=="oui" and str(norm)=="non" :
            b=betweenness_centrality(G, normalized=False, weight='weight')
        if str(indicateur)=="Betweenness" and str(poids)=="non" and str(norm)=="oui" :
            b=betweenness_centrality(G)
        if str(indicateur)=="Betweenness" and str(poids)=="oui" and str(norm)=="oui" :
            b=betweenness_centrality(G,weight='weight')
        if str(indicateur)=="Closeness" and str(poids)=="non" and str(norm)=="non":
            b=closeness_centrality(G, normalized=False)
        if str(indicateur)=="Closeness" and str(poids)=="oui" and str(norm)=="non":
            b=closeness_centrality(G, normalized=False, weight='weight')
        if str(indicateur)=="Closeness" and str(poids)=="non" and str(norm)=="oui":
            b=closeness_centrality(G)
        if str(indicateur)=="Closeness" and str(poids)=="oui" and str(norm)=="oui":
            b=closeness_centrality(G,distance=True)
        if str(indicateur)=="Clustering" and str(poids)=="non":
            b=clustering(G)
        if str(indicateur)=="Clustering" and str(poids)=="oui":
            b=clustering(G, weight='weight')
        if str(indicateur)=="Vulnerabilite" and str(poids)=="non":
            b=closeness_vitality(G)
        if str(indicateur)=="Vulnerabilite" and str(poids)=="oui":
            b=closeness_vitality(G, weight='weight')
        if str(indicateur)=="Degree" and str(norm)=="non":
            b=degree_centrality(G)
            taille=len(b)
            for k in range(taille):
                  b[k+1]=b[k+1]*(taille-1)
        if str(indicateur)=="Degree" and str(norm)=="oui":
            b=degree_centrality(G)
        taille=len(b)
        aLayer2 = allLayers[int(ind_noeud)]
        provider2 = aLayer2.dataProvider()
        nbcol=int(provider2.fieldCount())
        provider2.addAttributes([QgsField(str(indicateur), QVariant.Double)])
        aLayer2.startEditing()
        for k in range(taille):
           aLayer2.changeAttributeValue(k,nbcol,b[k+1])
        aLayer2.commitChanges()

